 // ***** ViaThinkSoftSimpleMessage.mc *****
 // This is the header section.
 // The following are message definitions.
//
//  Values are 32 bit values laid out as follows:
//
//   3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
//   1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
//  +---+-+-+-----------------------+-------------------------------+
//  |Sev|C|R|     Facility          |               Code            |
//  +---+-+-+-----------------------+-------------------------------+
//
//  where
//
//      Sev - is the severity code
//
//          00 - Success
//          01 - Informational
//          10 - Warning
//          11 - Error
//
//      C - is the Customer code flag
//
//      R - is a reserved bit
//
//      Facility - is the facility code
//
//      Code - is the facility's status code
//
//
// Define the facility codes
//


//
// Define the severity codes
//
#define STATUS_SEVERITY_SUCCESS          0x0
#define STATUS_SEVERITY_INFORMATIONAL    0x1
#define STATUS_SEVERITY_WARNING          0x2
#define STATUS_SEVERITY_ERROR            0x3


//
// MessageId: MSG_SUCCESS
//
// MessageText:
//
// Success: %1
//
#define MSG_SUCCESS                      ((DWORD)0x20000000L)

//
// MessageId: MSG_INFORMATIONAL
//
// MessageText:
//
// Info: %1
//
#define MSG_INFORMATIONAL                ((DWORD)0x60000001L)

//
// MessageId: MSG_WARNING
//
// MessageText:
//
// Warning: %1
//
#define MSG_WARNING                      ((DWORD)0xA0000002L)

//
// MessageId: MSG_ERROR
//
// MessageText:
//
// Error: %1
//
#define MSG_ERROR                        ((DWORD)0xE0000003L)

